unit mainf;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, Video, ExtCtrls,inifiles, StdCtrls, ComCtrls, Buttons,avicap,mmsystem;

type
  TMain = class(TForm)
    MainMenu1: TMainMenu;
    Datein1: TMenuItem;
    Beenden1: TMenuItem;
    Einstellungen1: TMenuItem;
    VideoTreiber1: TMenuItem;
    Panel1: TPanel;
    Video1: TVideo;
    GroupBox1: TGroupBox;
    CheckPrev: TCheckBox;
    CheckOverl: TCheckBox;
    Edit1: TEdit;
    Label1: TLabel;
    fps: TLabel;
    N1: TMenuItem;
    VideoQuelle1: TMenuItem;
    VideoFormat1: TMenuItem;
    VideoAnzeige1: TMenuItem;
    VideoKompession1: TMenuItem;
    CheckSkale: TCheckBox;
    Checkprop: TCheckBox;
    GroupBox2: TGroupBox;
    BtSPict: TButton;
    Button2: TButton;
    EditSPict: TEdit;
    GroupBox4: TGroupBox;
    BtStartStop: TBitBtn;
    StatusBar1: TStatusBar;
    BtnPara: TBitBtn;
    EdFile: TEdit;
    Timer1: TTimer;
    SaveDialog1: TSaveDialog;
    Aufzeichnungsparameter1: TMenuItem;
    N2: TMenuItem;
    procedure VideoTreiber1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Video1Status(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CheckPrevClick(Sender: TObject);
    procedure CheckOverlClick(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure VideoFormat1Click(Sender: TObject);
    procedure VideoQuelle1Click(Sender: TObject);
    procedure VideoAnzeige1Click(Sender: TObject);
    procedure VideoKompession1Click(Sender: TObject);
    procedure CheckSkaleClick(Sender: TObject);
    procedure CheckpropClick(Sender: TObject);
    procedure BtSPictClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Video1StatusCallback(Sender: TObject; nID: Integer;
      status: String);
    procedure BtStartStopClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure EditSPictDblClick(Sender: TObject);
    procedure EdFileDblClick(Sender: TObject);
    procedure Aufzeichnungsparameter1Click(Sender: TObject);
  private
   procedure updateBtn(stat:Boolean);
    { Private-Deklarationen}
  public
    { Public-Deklarationen}
  end;

var
  Main: TMain;

implementation

uses DlgTreiber, dlgaufz;

{$R *.DFM}

procedure TMain.VideoTreiber1Click(Sender: TObject);
begin
 DlgEinstell:=TDlgEinstell.Create(Self);
 dlgEinstell.Combobox1.Items:= GetDriverList;
 Video1.DriverOpen:= false;
 dlgEinstell.ComboBox1.Itemindex:= Video1.DriverIndex;
 if DlgEinstell.ShowModal = mrOK then
    begin
      video1.DriverIndex:= dlgEinstell.combobox1.ItemIndex;
    end;

 Video1.DriverOpen:= true;

 DlgEinstell.Free;
end;

procedure TMain.FormCreate(Sender: TObject);
var ini:TInifile;

begin
 ini:= TInifile.Create('vcap.ini');
 Video1.Driverindex:=ini.readInteger('Driver','index',-1);
 ini.free;
end;

procedure TMain.FormDestroy(Sender: TObject);
var ini:TInifile;

begin
 ini:= TInifile.Create('vcap.ini');
 ini.writeInteger('Driver','index',video1.Driverindex);
 ini.free;
end;


procedure TMain.Video1Status(Sender: TObject);
begin
if Video1.DriverIndex= -1 then
 begin
   checkprev.enabled := false;
   videoKompession1.Enabled:= false;
  end
else
begin
 checkprev.enabled:= true;
 videoKompession1.enabled:= true;
end;

 Edit1.Text:= inttostr(Video1.PreviewRate);
 checkOverl.Enabled:= Video1.HasVideoOverlay;
 checkprev.Checked:=Video1.VideoPreview;
 checkOverl.Checked:=Video1.VideoOverlay;
 VideoFormat1.enabled:= Video1.HasDlgFormat;
 VideoAnzeige1.Enabled:= Video1.HasDlgDisplay;
 VideoQuelle1.Enabled:= Video1.HasDlgSource;
end;

procedure TMain.FormShow(Sender: TObject);
begin
 Video1.DriverOpen:=True;
 editsPict.text:= Video1.SingleImageFile;
 edFile.Text:=Video1.VideoFileName;
 end;

procedure TMain.CheckPrevClick(Sender: TObject);
begin
 Video1.VideoPreview:=CheckPrev.Checked;

end;

procedure TMain.CheckOverlClick(Sender: TObject);
begin
 Video1.VideoOverlay:=CheckOverl.Checked;
end;

procedure TMain.Edit1Change(Sender: TObject);
var i:integer;
begin
try
 i:= strtoint(Edit1.Text);
 if (i > 0) and ( i < 30) then Video1.PreviewRate:=i;
except
end;
end;

procedure TMain.VideoFormat1Click(Sender: TObject);
begin
 Video1.DlgVFormat;
end;

procedure TMain.VideoQuelle1Click(Sender: TObject);
begin
 Video1.DlgVSource;
end;

procedure TMain.VideoAnzeige1Click(Sender: TObject);
begin
 video1.DlgVDisplay;
end;

procedure TMain.VideoKompession1Click(Sender: TObject);
begin
 video1.DlgVCompression;
end;

procedure TMain.CheckSkaleClick(Sender: TObject);
begin
 video1.PreviewScaleToWindow:=CheckSkale.Checked;
end;

procedure TMain.CheckpropClick(Sender: TObject);
begin
Video1.PreviewScaleProportional:=Checkprop.Checked;
end;

procedure TMain.BtSPictClick(Sender: TObject);
begin
Video1.SingleImageFile:= EditSPict.Text;
Video1.GrabFrameNoStop;

if not Video1.SaveAsDib then
 MessageDlg('Bild konnte nicht gespeichet werden',mtError,[mbOK],0)
else
 MessageDlg('Bild wurde gespeichet',mtInformation,[mbOK],0);
end;


procedure TMain.Button2Click(Sender: TObject);
begin
 Video1.GrabFrameNoStop;
 Video1.SaveToClipboard;
end;

procedure TMain.Video1StatusCallback(Sender: TObject; nID: Integer;
  status: String);
begin
StatusBar1.Panels[0].Text:= status;

end;

procedure TMain.BtStartStopClick(Sender: TObject);
begin
 if Video1.CapInProgess then
 begin
  Video1.StopCapture ;
  UpdateBtn(false)
  end
 else
 begin
    Video1.VideoFileName:= edFile.Text;
    Video1.StartCapture;
    Timer1.Enabled:= True;
    updateBtn(true);
 end;

end;

procedure TMain.UpdateBtn(stat:boolean);

begin

if stat then
  begin
    BtStartStop.caption:= 'Stop';
    btStartStop.Font.Color:= clgreen;
  end
  else
   begin
    BtStartStop.caption:= 'Start';
    btStartStop.Font.Color:= clred;
    Timer1.Enabled:= false;
   end;
 end;

procedure TMain.Timer1Timer(Sender: TObject);
begin
 updateBtn(Video1.CapInProgess);
end;

procedure TMain.EditSPictDblClick(Sender: TObject);
begin
 SaveDialog1.Filter:='Bildateien (*.bmp)|*.bmp';
 SaveDialog1.FileName:= editspict.text;
 if SaveDialog1.Execute then
  editspict.Text:=saveDialog1.filename;
end;

procedure TMain.EdFileDblClick(Sender: TObject);
begin
  SaveDialog1.Filter:='Videodateien (*.avi)|*.avi';
  SaveDialog1.FileName:= edfile.text;
  if saveDialog1.Execute then
   edFile.text:= saveDialog1.FileName;
end;

procedure TMain.Aufzeichnungsparameter1Click(Sender: TObject);
begin
dlgVpara:=TDlgVPara.Create(Self);
DlgVPara.ShowModal;
dlgvpara.Free;
end;

end.
